/////////////////////////////////////////////////////////////////////////////////////////
//inport.h
//Written By Kenichi OHARA, Arai Lab, Osaka University
//
//InPort֘A̐ݒ
/////////////////////////////////////////////////////////////////////////////////////////
#ifndef _INPORT_H_
#define _INPORT_H_
#include "rtc_message.h"

/////////////////////////////////////////////////////////////////////////////////////////
//InPort̃f[^tH[}bg
//0Byte	:0xFF (wb_)
//1Byte  :INPORT_PUT
//2Byte  :INPORT_ID
//3Byte  :INPORT_DATA_LEN
//4Byte- :Mf[^(Ō̓`FbNT)
/////////////////////////////////////////////////////////////////////////////////////////
#define INPORT_PUT      1
#define INPORT_ID       2
#define INPORT_DATA_LEN 3
#define INPORT_DATA_POS 4

//InPort̃|[g̐ݒ
#define INPORT_NUM 2

/////////////////////////////////////////////////////////////////////////////////////////
//ϐ`
/////////////////////////////////////////////////////////////////////////////////////////
//*****************************************************
//InPortp̃f[^obt@ƃf[^|[gXg
//*****************************************************
BYTE		*g_inport_p[INPORT_NUM];
int   	g_inport_len[INPORT_NUM];

//*****************************************************
//InPort1`
//*****************************************************
#define	DIO_LEN	4
#define	DIO_ID	0
long	g_DioIn;

/////////////////////////////////////////////////////////////////////////////////////////
//֐`
/////////////////////////////////////////////////////////////////////////////////////////
void rtc_inport_init();
void rtc_parse_inport_cmd();

/////////////////////////////////////////////////////////////////////////////////////////
//֐{̂̎
/////////////////////////////////////////////////////////////////////////////////////////
//=====================================================
//InPort̏
//=====================================================
void rtc_inport_init(){
	g_inport_p[DIO_ID]    = (BYTE*)g_DioIn;
	g_inport_len[DIO_ID]  = DIO_LEN;
}

//=====================================================
//InPortR}h̉
//=====================================================
void rtc_parse_inport_cmd(){
	int id;
	int i;
	unsigned int len;
	BYTE* data_p;
	id = rtc_message_get(INPORT_ID);
  
	if(id > (INPORT_NUM - 1)){
		RTM_ACK_ERR;
	}
	else{
		//V[up̃obt@e|̃obt@ɃRs[
		data_p = (BYTE*)g_inport_p[rtc_message_get(INPORT_ID)];
    		//f[^̒̎擾
    		len = rtc_message_get(INPORT_DATA_LEN);
  
		//Mobt@InPort̃obt@ɃRs[
		for (i = 0; i < len; i++, data_p++){
			*data_p = rtc_message_get(INPORT_DATA_POS + i);
		}
		RTM_ACK_OK;
	}
	return;
}

#endif
