/////////////////////////////////////////////////////////////////////////////////////////
//outport.h
//Written By Kenichi OHARA, Arai Lab, Osaka University
//
//OutPort֘A̐ݒ
/////////////////////////////////////////////////////////////////////////////////////////
#ifndef _OUTPORT_H_
#define _OUTPORT_H_
#include "rtc_message.h"

/////////////////////////////////////////////////////////////////////////////////////////
//OutPort̃f[^tH[}bg
//0Byte	:0xFF (wb_)
//1Byte  :OUTPORT_PUSH
//2Byte  :OUTPORT_ID
//3Byte  :OUTPORT_DATA_LEN
//4Byte- :Mf[^(Ō̓`FbNT)
/////////////////////////////////////////////////////////////////////////////////////////
#define OUTPORT_PUSH     1
#define OUTPORT_GET      1
#define OUTPORT_ID       2
#define OUTPORT_DATA_LEN 3
#define OUTPORT_DATA_POS 4

//OutPort̐ݒ
#define OUTPORT_NUM 4

/////////////////////////////////////////////////////////////////////////////////////////
//ϐ`
/////////////////////////////////////////////////////////////////////////////////////////
//*****************************************************
//OutPortp̃f[^obt@ƃf[^|[gXg
//*****************************************************
BYTE		*g_outport_p[OUTPORT_NUM];
int		g_outport_len[OUTPORT_NUM];

//*****************************************************
//OutPort1`
//rtc-templateŏo͂vf
//*****************************************************
#define	ADDATA_LEN 4
#define	ADDATA_ID  0
long	g_AddataOut;

/////////////////////////////////////////////////////////////////////////////////////////
//֐`
/////////////////////////////////////////////////////////////////////////////////////////
void	rtc_outport_init();
void	rtc_parse_outport_cmd();
void	rtc_outport_push(BYTE id);
void	rtc_outport_write(BYTE id, BYTE len, BYTE* data);
void	rtc_outport_begin(unsigned int id, unsigned int len);
void	rtc_outport_putc(int data);
void	rtc_outport_end();

/////////////////////////////////////////////////////////////////////////////////////////
//֐{̂̎
/////////////////////////////////////////////////////////////////////////////////////////
//=====================================================
//OutPort̏
//=====================================================
void rtc_outport_init(){
	///////////////////////////////////
	//rtc-templateŏo͂vf
	///////////////////////////////////
	//OutPort1̃Xgւ̓o^ƕϐ̏
	g_outport_p[ADDATA_ID]   = (BYTE*)g_AddataOut;
	g_outport_len[ADDATA_ID] = ADDATA_LEN;

	g_AddataOut = 0;
	///////////////////////////܂
}

//=====================================================
//OutPortR}h̉
//=====================================================
void rtc_parse_outport_cmd(){
	int id;
	id = rtc_message_get(OUTPORT_ID);
	if (id > (OUTPORT_NUM - 1)) {
		RTM_ACK_ERR;
	}
	else {
		rtc_outport_push(id);
	}
}

//=====================================================
//OutPortf[^̏o
//=====================================================
void rtc_outport_push(BYTE id){
	rtc_outport_write(id, g_outport_len[id], g_outport_p[id]);
}

//=====================================================
//OutPortf[^̏o
//=====================================================
void rtc_outport_write(BYTE id, BYTE len, BYTE* data){
	int i;
	//wb_̑M
	rtc_message_begin();
	//OutPortR}h̑M
	rtc_message_putc(OUTPORT_CMD);
	//OutPortID̑M
	rtc_message_putc(id);
	//f[^̑M
	rtc_message_putc(len);
	//f[^̒g̑M
	for (i = 0; i < len; ++i){
		rtc_message_putc(*data);
		++data;
    }
    rtc_message_end();
}

#endif
